package flow.components

import chisel3._
import chisel3.util.BitPat
import chisel3.util.MuxLookup

object util {
  implicit class enumToUInt[T <: EnumType](e: T) {
    def U = {
      e.asUInt
    }
    def BP = {
      BitPat(e.litValue.toInt.U(e.getWidth.W))
    }
  }

  import scala.language.implicitConversions
  implicit def chiselEnumAsInt[T <: EnumType](e: T): Int = {
    e.litValue.toInt
  }

  object MuxBindCtrlSrc {
    def apply[E <: EnumType, T <: Data](ctrl: E, src: Vec[T], default: T) = {
      val map = (0 until src.length).map(_.U).zip(src)
      MuxLookup(ctrl.U, default)(map)
    }
  }
}
