package flow.stages

import chisel3._
import chisel3.util.Decoupled
import chisel3.util.DecoupledIO
import flow.Params
import flow.stages.utils._
import flow.stages.messages._
import chisel3.experimental.Trace._

class WB(implicit val p: Params) extends Module {
  // val msgio = IO(DecoupledMsgIO(in = (new LS2WB).S))
  val io = IO(new Bundle {
    val toID = Output(new WB2ID)
  })
  val msgio = IO(new Bundle {
    val in = Flipped(DecoupledIO(new LS2WB))
  })
  msgio.in.ready := DontCare

  private val _in = msgio.in.bits
  private val _toID = io.toID

  _toID.exeOut := _in.exeOut;
  _toID.memOut := _in.memOut;
  _toID.regCtrl := _in.regCtrl;
  _toID.rd := _in.rd
  _toID.npc := _in.pc + 4.U

  traceName(_in.pc)
  traceName(_in.rd)
}
