package flow

import io.circe.generic.JsonCodec

// Which group of signals to trace
@JsonCodec case class TraceConfig(
    enable: Boolean = false,
    registers: Array[Int] = Array(),
    mem: Array[(Int, Int)] = Array()
)

@JsonCodec case class Config(
    // Whether to enable Difftest
    enableDifftest: Boolean = true,
    traceConfig: TraceConfig = TraceConfig()
)

import chisel3._
case class Params(
    XLEN: Width,
    instWidth: Width = 32.W,
    regsCount: Int = 32,
    regsAddrWidth: Width = 5.W,
    regsResetValue: BigInt = 0L,
    arch: String,
    csrAddrWidth: Width = 12.W,
    resetVector: BigInt = BigInt(0x80000000L)
)
