package flow

import scala.reflect.runtime.universe._
import chisel3._
import chisel3.util.experimental.decode.{decoder, TruthTable}
import chisel3.util._
import chisel3.experimental.Trace._
import shapeless.{HNil, ::}
import shapeless.HList
import shapeless.ops.coproduct.Prepend
import chisel3.util.{BinaryMemoryFile, HexMemoryFile}

import chisel3.experimental.Trace
import scala.collection.IndexedSeqView
import shapeless.Poly1
import flow.components.DpiRamControlInterface
import flow.components.RV32Inst
import flow.components.RV32InstSubfields._
import flow.components.util._

import flow.components.{RegControl, PcControlInterface, ALUControlInterface}

import flow.stages._
import chisel3.experimental.annotate
import chisel3.experimental.ChiselAnnotation

import chisel3.Data
import chisel3.experimental.{annotate, requireIsAnnotatable, ChiselAnnotation}

class Flow extends Module {
  implicit val p: Params = new Params(XLEN = 32.W, arch = "single")
  val IF = Module(new IF)
  val ID = Module(new ID)
  val EX = Module(new EX)
  val LS = Module(new LS)
  val WB = Module(new WB)
  // IF.msgio connect ID.msgio connect EX.msgio connect LS.msgio connect [Nothing] WB.msgio
  ID.msgio.in :<>= IF.msgio.out
  EX.msgio.in :<>= ID.msgio.out
  LS.msgio.in :<>= EX.msgio.out
  WB.msgio.in :<>= LS.msgio.out

  IF.io.fromRam := LS.io.toIF
  IF.io.fromEx := EX.io.toIF
  LS.io.fromIF := IF.io.toRam
  ID.io.fromWB := WB.io.toID
}
